if (LUA["HATS"] ~= nil) then return end

local DIR = DIR .. "data\\hats\\"
local ACCOUNT_DIR = DIR .. "accounts\\"

local DIVISION_HATS = 5

local LIST_HATS = {}
local MAX_PAGES = {}

local player_menustatus = {}
local player_page = {}
local player_hat = {}

function load_hats()
	local listhats = io.popen(("dir %s*.png /b"):format(DIR))
	local servertransfer = io.open("sys/servertransfer.lst", "a")
	local count = 0
	
	local tm = os.clock()

	for hat in (listhats:lines()) do
		table.insert(LIST_HATS, hat)
		count = count + 1
		
		if servertransfer_hat(hat) then
			servertransfer:write("\n" .. DIR .. hat)
		end
	end
	servertransfer:close()
	print(("%d hats loaded in %f seconds"):format(count, os.clock() - tm))
	MAX_PAGES = math.floor(#LIST_HATS / DIVISION_HATS)
end

function servertransfer_hat(hat)
	for line in io.lines("sys/servertransfer.lst") do
		if line:find(hat) then
			return false
		end
	end
	return true
end

function wear_hat(id, hatid)
	local hat = LIST_HATS[hatid]
	if (hat == nil) then
		msg2(id,("255000000Hat not exists! 255255000[ID: %d]@C"):format(hatid)) 
		return
	end
	
	remove_hat(id)
	player_hat[id] = {["imageid"] = image(DIR .. hat, 3, 0, id + 200),
					  ["hatid"] = hatid}
end

function remove_hat(id)
	if (player_hat[id]["imageid"] ~= nil) then
		freeimage(player_hat[id]["imageid"])
		player_hat[id] = {}
	end
end

function hatname(hatid)
	local hat = LIST_HATS[hatid]
	if (hat == nil) then return "" end
	
	return hat:sub(1, #hat - 4) 
end

function hats_menu(id, PAGE)
	
	if (PAGE == nil) then PAGE = 1 end
	
	if (PAGE == 0) then
		if (player_hat[id]["hatid"] ~= nil) then
			PAGE = math.floor(player_hat[id]["hatid"] / DIVISION_HATS)
			if (PAGE == 0) then PAGE = 1 end
		else
			PAGE = math.random(1, MAX_PAGES)
		end
	end

	local title = ("HATS [%d/%d]"):format(PAGE, MAX_PAGES)
	local buttons = ""
	
	for button = 1, 9 do
		if (button == 7) then
			buttons = buttons .. ","
		elseif (button == 8 and PAGE == 1) then
			buttons = buttons ..",LAST PAGE|>>>"
		elseif (button == 8 and PAGE == MAX_PAGES) then
			buttons = buttons .. ",FIRST PAGE|<<<"
		elseif (button == 8) then
			buttons = buttons ..",PREVIOUS PAGE|<"
		elseif (button == 9 and PAGE == MAX_PAGES) then
			buttons = buttons .. ",PREVIOUS PAGE|<"
		elseif (button == 9) then
			buttons = buttons .. ",NEXT PAGE|>"
		else
			button = button + 6*(PAGE - 1)
			if (hatname(button) == hatname(player_hat[id]["hatid"])) then
				buttons = buttons .. "," .. hatname(button) .. "|[X]"
			else
				buttons = buttons .. "," .. hatname(button) .. "|[  ]"
			end
		end
	end
	
	player_page[id] = PAGE
	player_menustatus[id] = true
	menu(id, title .. buttons)
end

function save_options_hats(id, save)

	if (player_hat[id]["hatid"] == nil) then print("255000000Save hat ERR. Please put on hat! id: " .. id) return end
	
	local usgn = player(id, "usgn")
	local steamid = player(id, "steamid")
	
	if (save == nil) then
		if (usgn ~= 0) then
			local filesave = io.open(ACCOUNT_DIR .. usgn .. ".usgn", "w")
			filesave:write("hatid = " .. player_hat[id]["hatid"] .. "\n")
			filesave:write("page = " .. player_page[id] .. "\n")
			filesave:close()
			print(("hats saved USGN: [%s]"):format(usgn))
		end
		
		if (steamid ~= "0") then
			local filesave = io.open(ACCOUNT_DIR .. steamid .. ".steamid", "w")
			filesave:write("hatid = " .. player_hat[id]["hatid"] .. "\n")
			filesave:write("page = " .. player_page[id] .. "\n")
			filesave:close()
			print(("hats saved STEAMID: [%s]"):format(steamid))
		end
	else
		if (tostring(player(id, save:lower())) == "0") then return print("255000000Save hat ERR. got no account") end
		local filesave = io.open(("%s%s.%s"):format(ACCOUNT_DIR, player(id, save:lower()), save:lower()), "w")
		filesave:write("hatid = " .. player_hat[id]["hatid"] .. "\n")
		filesave:write("page = " .. player_page[id] .. "\n")
		filesave:close()
		print(("hats saved %s: [%s]"):format(save:upper(), player(id, save:lower())))
	end
end

function save_options_menu(id)
	local title = "Select Account@b"
	local buttons = ","
	
	local usgn = player(id, "usgn")
	local steamid = player(id, "steamid")
	
	if (steamid ~= "0") then buttons = buttons .. "STEAMID:|" .. steamid  .. "," end
	if (usgn ~= 0) then buttons = buttons .. "USGN:|" .. usgn .. "," end

	menu(id, title .. buttons)
end

function load_save_hats(id)
	if not player(id, "exists") then return end
	
	local whatsave = nil
	
	if (player(id, "steamid") ~= "0") then
		whatsave = player(id, "steamid") .. ".steamid"
	elseif (player(id, "usgn") ~= 0) then
		whatsave = player(id, "usgn") .. ".usgn"
	end
	
	if (whatsave == nil) then return end
	
	local filesave = io.open(ACCOUNT_DIR .. whatsave, "r")
	if (filesave ~= nil) then
		for line in (filesave:lines()) do assert(loadstring(line))() end
		player_page[id] = page
		hat_loop(id .. " " .. hatid)
		filesave:close()
		page, hatid = nil, nil
	end
end

function hat_loop(args)
	local args = string_totable(args)
	
	local id = tonumber(args[1])
	local hatid = tonumber(args[2])
	
	if not player(id, "exists") then return end
	
	if (player(id, "health") > 0) then
		wear_hat(id, hatid)
		return
	end
	
	timer(100, "hat_loop", id .. " "..hatid)
end

function menu_hook_hats(id, title, button)
	local PAGE = player_page[id]
	if (title == ("HATS [%d/%d]"):format(PAGE, MAX_PAGES)) then
		if (button >= 1 and button <= 6) then
			button = button + 6 * (PAGE-1)
			if (button == player_hat[id]["hatid"]) then 
				remove_hat(id)
			else
				wear_hat(id, button)
			end
			hats_menu(id, PAGE)
		elseif (button == 8 and PAGE == 1) then
			hats_menu(id, MAX_PAGES)
		elseif (button == 8 and PAGE == MAX_PAGES) then
			hats_menu(id, 1)
		elseif (button == 8) then
			hats_menu(id, PAGE - 1)
		elseif (button == 9 and PAGE == MAX_PAGES) then
			hats_menu(id, PAGE - 1)
		elseif (button == 9) then
			hats_menu(id, PAGE + 1)
		else
			player_menustatus[id] = false
		end
	end
end

function leave_hook_hats(id, reason)
	if (reason >= 0 and reason <= 2) then
		save_options_hats(id)
		remove_hat(id)
	end
end

function serveraction_hook_hats(id, act)
	if (act == 1) then
		if (player(id, "health") > 0) then
			hats_menu(id,player_page[id])
		end
	elseif (act == 2) then
		save_options_menu(id)
	end
end

function die_hook_hats(id)
	if player_menustatus[id] then
		menu(id, "SORRY,")
		player_menustatus[id] = false
	end
end

function join_hook_hats(id)
	player_hat[id] = {}
	player_menustatus[id] = false
	player_page[id] = 1
	load_save_hats(id)
end

load_hats()
